<?php header("Content-type: text/html; charset=utf-8");

// ----------------------------------------------------- //
// Loudblog                                              //
// easy-to-use mediablogging and podcasting              //
// Version 0.5 (2006-07-15)                              //
// http://loudblog.de                                    //
//                                                       //
// Written by Gerrit van Aaken (gerrit@praegnanz.de)     //
//                                                       //
// Released under the Gnu General Public License         //
// http://www.gnu.org/copyleft/gpl.html                  //
//                                                       //
// Have Fun! Drop me a line if you like Loudblog!        //
// ----------------------------------------------------- //

#################################################
#################################################


////////////////// SOME INITIAL STUFF


//for developing we need some error messages
error_reporting(E_ALL);

//include database stuff and functions
include "custom/config.php";
include "inc/database/adodb.inc.php";
include "inc/connect.php";
include "inc/functions.php";

//magic quotes are evil!
if (get_magic_quotes_gpc()) {
   $_GET   = array_map('stripslashes_deep', $_GET);
   $_POST  = array_map('stripslashes_deep', $_POST);
}


//create some important globals
if (!isset($db['host'])) {
    die("<br /><br />Cannot find a valid configuration file! <a href=\"install.php\">Install Loudblog now!</a>");
}

$GLOBALS['prefix'    ] = $db['pref'];
$GLOBALS['path']       = $lb_path;
$GLOBALS['audiopath']  = $lb_path . "/audio/";
$GLOBALS['uploadpath'] = $lb_path . "/upload/";

//getting basic data
$settings = getsettings();
dumpdata();

//cannot find a session? start one!
//found a session? fetch the variables!
@session_set_cookie_params (60 * 60 * 24 * 30);
@session_start();

//we want to logout? delete this session!
if ((isset($_GET['do'])) AND ($_GET['do'] == 'logout')) {
    session_unset();
    session_destroy();
}


////////////////// CHECK THE USER-LOGIN



$access = false;

//no login-information in session-vars or post-data? no access!!
if (!isset($_SESSION['nickname']) AND !isset($_POST['nickname']))
    $access = false;

else {

    //fetch user-logins and passwords from database
    $dosql = "SELECT nickname, password FROM ".$GLOBALS['prefix']."lb_authors";
    $result = $GLOBALS['lbdata']->GetArray($dosql);

    //compare with the login-data from session and from post
    foreach ($result as $row) {
        if ((isset($_SESSION['nickname']))
        AND ($row['nickname'] == $_SESSION['nickname'])
        AND ($row['password'] == $_SESSION['password'])
        AND ($_SERVER['REMOTE_ADDR'] == $_SESSION['ipnumber']))
        $access = true;

        else {
            if ((isset($_POST['nickname']))
            AND ($row['nickname'] == $_POST['nickname'])
            AND ($row['password'] == md5($_POST['password'])))
            $access = true;
        }
    }
}




////////////////// WHICH CONTENT DO WE SHOW?

//get the language translation table
global $lang;
$lang = array();
@include_once($GLOBALS['path']."/loudblog/lang/".$settings['language'].".php");

//show the html-head which is always needed
include "inc/head.php";

//show the login-screen if access is denied
if (!$access) include "inc/backend_login.php";

//do other things if access is granted
else {

    //write login-data into session-data (if needed)
    if (!isset($_SESSION['nickname'])) {
        session_register ('nickname');
        session_register ('password');
        session_register ('ipnumber');
        session_register ('authorid');
        $_SESSION['nickname'] = $_POST['nickname'];
        $_SESSION['authorid'] = getuserid($_POST['nickname']);
        $_SESSION['password'] = md5($_POST['password']);
        $_SESSION['ipnumber'] = $_SERVER['REMOTE_ADDR'];
    }

    //no url request? show postings as default
    if (!isset($_GET['page'])) { $loadme = "inc/backend_postings.php"; }

    //build an include-path from the url-request
    else {
    $requested_page = killevilcharacters(strip_tags($_GET['page']));
    $loadme = "inc/backend_" . $requested_page . ".php";
    }
    
    //we don't want our users to run update scripts manually, do we?
    include "inc/autoupdate.php";

    //yee-hah! finally we do show real content on our page!
    include ($loadme);

}

include "inc/footer.php";

?>